<?php
/*
  $Id: HomeCredit.php
  Verzia 1.1, 2007-12-03
  Vytvoril: Daniel Medo, Microart Design
  
  Za pomoc s testovanim dakujem Petrovi Adamekovi
  
  Autor tohto platobneho modulu nezodpoveda za ziadne skody
  sposobene tymto modulom, to znamena ze tento modul si uzivatel
  instaluje na vlastne riziko.
  
  Hlavicka tohto suboru (text, ktory prave citate) nesmie byt
  odstranena z tohto dokumentu.
  
  **************************************************************
  

  Copyright (c) 2002-2007 osCommerce, Open Source E-Commerce Solutions  http://www.oscommerce.com
  Released under the GNU General Public License
*/

require_once 'includes/configure.php';

  class HomeCredit extends base{
    var $code, $title, $description, $enabled;

    function HomeCredit() {
      $this->code = 'HomeCredit';
      $this->title = MODULE_PAYMENT_HOMECREDIT_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_HOMECREDIT_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_HOMECREDIT_SORT_ORDER;
      $this->enabled = (MODULE_PAYMENT_HOMECREDIT_STATUS == 'True' ? true : false);
      
      if ((int)MODULE_PAYMENT_HOMECREDIT_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_HOMECREDIT_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();
      
      $this->form_action_url = MODULE_PAYMENT_HOMECREDIT_SERVER_URL;
    }
    
// class methods
    function update_status() {
      global $order, $db;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_HOMECREDIT_ZONE > 0) ) {
        $check_flag = false;
        $check = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_HOMECREDIT_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
        while (!$check->EOF) {
          if ($check->fields['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check->fields['zone_id'] == $order->delivery['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

////
// Get url
    function get_url() {
        if (ENABLE_SSL_ADMIN == 'true') {
          $link = HTTPS_SERVER . DIR_WS_HTTPS_CATALOG . 'redirect_to_payment.php';
        } else {
          $link = HTTP_SERVER . DIR_WS_CATALOG . 'redirect_to_payment.php';
        }
        
        return $link;
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }
    
    function confirmation() {
      return false;
    }

    function process_button() {
      global $order, $db;
      
      //$table_status = $db->Execute("show TABLE STATUS like '" . TABLE_ORDERS . "'");
      //$last_order_id = $table_status->fields['Auto_increment'];
      $order_total = number_format(($order->info['total'] * $order->info['currency_value']), 2, ',', '');
      $all_products_names = '';
      $all_products_manufacturers = '';
      $thetime = date("d.m.Y-H:i:s");
      for ($a = 0; $a < count($order->products); $a++) {
        $all_products_names .= $order->products[$a]['name'];
        $man_name = $db->Execute("select m.manufacturers_name as name from " . TABLE_MANUFACTURERS . " m, " . TABLE_PRODUCTS . " p where p.products_id = " .
         (int)$order->products[$a]['id'] . " and m.manufacturers_id = p.manufacturers_id");
        $all_products_manufacturers .= $man_name->fields['name'];
      }
            
      $c_name = substr($order->billing['firstname'], 0, 30);
      $c_surname = substr($order->billing['lastname'], 0, 30);
      $all_products_names = substr($all_products_names, 0, 60);
      $all_products_manufacturers = substr($all_products_manufacturers, 0, 50);
      $ret_url = $this->get_url();
    
      $required = MODULE_PAYMENT_HOMECREDIT_SID . $_SESSION['customer_id'] . $order_total . $c_name . $c_surname . $all_products_names .
          $all_products_manufacturers . $thetime . MODULE_PAYMENT_HOMECREDIT_SS;
    
      $md5hash = md5($required);
    
      $url_params = zen_draw_hidden_field('shop', MODULE_PAYMENT_HOMECREDIT_SID) .
                  zen_draw_hidden_field('o_code', $_SESSION['customer_id']); //$last_order_id) .
                  zen_draw_hidden_field('o_price', $order_total) .
                  zen_draw_hidden_field('c_name', $c_name) .
                  zen_draw_hidden_field('c_surname', $c_surname) .
                  zen_draw_hidden_field('g_name', $all_products_names) .
                  zen_draw_hidden_field('g_producer', $all_products_manufacturers) .
                  zen_draw_hidden_field('ret_url', $ret_url) .
                  zen_draw_hidden_field('time_request', $thetime) .
                  zen_draw_hidden_field('sh', $md5hash);
                   
            
      return $url_params;
    }

    function before_process() {
      $hc_ret = zen_db_prepare_input($_GET['hc_ret']);
      $hc_o_code = (int)$_GET['hc_o_code'];
      $hc_sh = zen_db_prepare_input($_GET['hc_sh']);
      $hc_evid = zen_db_prepare_input($_GET['hc_evid']);

      // if the order was not approved, cancel it
      if ($hc_ret === 'N')
          zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode(MODULE_PAYMENT_HOMECREDIT_TEXT_DENIED), 'SSL', true, false));
      if ($hc_ret === 'L')
          zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode(MODULE_PAYMENT_HOMECREDIT_TEXT_LEAVED_OVER), 'SSL', true, false));

      $order_status = $query->fields['orders_status_id'];
      $order_comments = $query->fields['comments'];
      $required = $hc_ret . $hc_o_code . MODULE_PAYMENT_HOMECREDIT_SS;
      $my_hash = md5($required);

      // if hash is not correct, cancel the order too
      if ($hc_sh != $my_hash || $hc_ret != 'Y')
          zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode(MODULE_PAYMENT_HOMECREDIT_TEXT_LEAVED_OVER), 'SSL', true, false));

      return false;
    }

    function after_process() {
        return false;    
    }

    function output_error() {
      return false;
    }

    function check() {
      global $db;
      if (!isset($this->check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_HOMECREDIT_STATUS'");
        $this->check = $check_query->RecordCount();
      }
      return $this->check;
    }

    function install() {
      global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Povoli platby cez HomeCredit?', 'MODULE_PAYMENT_HOMECREDIT_STATUS', 'True', 'Chcete povoli platby cez HomeCredit?', '6', '1', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ID obchodu', 'MODULE_PAYMENT_HOMECREDIT_SID', '55', 'Identifiktor obchodu (Poskytne vm ho firma HomeCredit).', '6', '2', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Tajn reazec', 'MODULE_PAYMENT_HOMECREDIT_SS', '1234567890', 'Tajn reazec (Poskytne vm ho firma HomeCredit).', '6', '3', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Odkaz (I-Shop)', 'MODULE_PAYMENT_HOMECREDIT_SERVER_URL', 'https://i-shopsk.homecredit.net/ishop/entry.do', 'Odkaz na HomeCredit server, na ktor sa bud odosiela daje z tohto obchodu pri nkupe cez HomeCredit modul', '6', '4', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Platobn zna', 'MODULE_PAYMENT_HOMECREDIT_ZONE', '0', 'Ak je vybran zna, platba bude povolen len pre tto znu.', '6', '5', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Poradie zobrazenia', 'MODULE_PAYMENT_HOMECREDIT_SORT_ORDER', '0', 'Poradie zobrazenia. Najniie slo je zobrazen ako prv.', '6', '6', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Nastavi stav objednvok', 'MODULE_PAYMENT_HOMECREDIT_ORDER_STATUS_ID', '0', 'Nastavi stav objednvok vytvorench tmto platobnm modulom na tto hodnotu.', '6', '7', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Odkaz (I-Calc)', 'MODULE_PAYMENT_HOMECREDIT_SERVER_ICALC_URL', 'https://i-calcsk-train.homecredit.net/icalc/entry.do', 'Odkaz na HomeCredit server, na ktor sa bud odosiela daje pre kalkulciu vky veru produktu z product_info.php', '6', '8', now())");
    }

    function remove() {
      global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      $keys = array('MODULE_PAYMENT_HOMECREDIT_STATUS', 'MODULE_PAYMENT_HOMECREDIT_SID', 'MODULE_PAYMENT_HOMECREDIT_SS', 'MODULE_PAYMENT_HOMECREDIT_SERVER_URL', 'MODULE_PAYMENT_HOMECREDIT_ZONE', 'MODULE_PAYMENT_HOMECREDIT_SORT_ORDER', 'MODULE_PAYMENT_HOMECREDIT_ORDER_STATUS_ID', 'MODULE_PAYMENT_HOMECREDIT_SERVER_ICALC_URL');

      return $keys;
    }
  }
?>
